<html>
<head>
<title>RManNotes: Regular Patterns: Transitions</title>
</head>

<body bgcolor="#f9f9b1" background="notepad.gif" link="801010" vlink="101080" alink="108010"> <img alt="RManNotes" align=center src="header.gif">

<img align=center hspace=10 src="reg_patterns.gif">

<p><img src="black_line.gif"></p>
<p>
<a href="tiling.html">previous</a>
|
<a href="mod.html">next</a>
|
<a href="index.html">regular patterns: <b>contents</b></a>
|
<a href="../index.html">rmannotes: <b>top</b></a>
</i>
</p>
<p><img src="black_line.gif"></p>

<h1><a name="top">Transitions</a></h1>

<p>
A tile for a surface shader generally has some transition in color or opacity.
A tile for a displacement shader has transitions in the amount of displacement.
Transitions can be described functionally using simple, 
"building block" functions like
<a href="#step">step</a>, <a href="#smoothstep">smoothstep</a>, 
and <a href="#pulse">pulse</a>.
Once a tile has been created, it can easily be repeated using the 
<a href="mod.html#top">mod function</a>.
</p>

<p align=center>
<small>Some of the figures in this section were adapted from 
<a href="../references.html">[Apodaca92]</a>.</small>
</p>

<h2><a name="step">Step</a></h2>

<p>
The <b><i>step function</i></b> acts like a switch jumping from 0 to 1 
when the variable, <i>x</i>, is greater than some threshold, <i>a</i>.
</p>

<p align=center>
<img src="step.gif"><br>
<code>step(a, x)</code>
</p>

<p>
step is equivalent to a conditional statement. For example,
<pre>
s = step(a, x)
</pre>
is equivalent to the following code fragment:
<pre>
if (x &lt a)
  s = 0;
else
  s = 1;
</pre>
</p>

<p>
The primary motivation for considering <code>step</code> instead 
of conditionals is because <code>step</code> can be replaced 
functionally with the 
<a href="#smoothstep"><i>smoothstep function</i></a>. <code>step</code>
contains arbitrarily high frequency components meaning that shaders
written with <code>step</code> (or conditionals) will almost always
alias. <code>smoothstep</code>, however, does not contain arbitrarily
high frequency components -- therefore <code>smoothstep</code> can
be used to generate sharp transitions which do not alias.
</p>

<h2><a name="smoothstep">Smoothstep</a></h2>

<p>
The <b><i>smoothstep</i></b> function is similar 
to <a href="#step"><code>step</code></a>, 
but provides a smooth transition from 0 to 1. When the variable 
<i>x</i> is greater than the value <i>a</i> the function starts changing 
from 0 to 1. By the time the variable <i>x</i> reaches the 
value <i>b</i>, the transition has completed and the value of 
<code>smoothstep</code> is 1.
</p>

<p align=center>
<img src="smoothstep.gif"><br>
<code>smoothstep(a, b, x)</code>
</p>

<p>
For antialiasing purposes, we can think of the smoothstep function 
as the step function with a controllable amount of blurriness 
or "fuzz." If <code>fuzz</code>
is set properly, we have a antaliased version of <code>step</code>. Note
that if <code>fuzz</code> = 0, we have the original step function.
</p>

<center>
<table>
<caption><b>step and "fuzzy" step</b></caption>
<tr><td><img src="step.gif">
<td><img src="smoothstep2.gif">
<tr align=center><td><code>step(a, x)</code>
<td><code>smoothstep(a - fuzz, a, x)</code>
</table>
</center>

<p>
<i>Note:</i> The reason for specifying the smooth transition 
from <i>a - fuzz</i> to <i>a</i> is described by Peachey in the
subsection titled "Filter Position" in Chapter 2 (page 97) of 
<a href="../references.html">[Ebert94]</a>.</i>
</p>

<h2><a name="pulse">Pulse</a></h2>

<p>
A <b><i>pulse</i></b> 
is one of the most commonly used building blocks in shaders. 
It represents a sharp, temporary transition 
defined over some range. A <b><i>square pulse</i></b> 
is created by subtracting one 
<a href="#step">step function</a> from another.
</p>

<p align=center>
<img src="square_pulse.gif"><br>
a square pulse, <code>step(<i>a, x</i>) - step(<i>b, x</i>)</code>
</p>

<p>
But, square pulses have the same problem with aliasing that individual step 
functions have. Fortunately, two 
<a href="#smoothstep">smoothsteps</a> can be combined in the same way 
to generate a <b><i>rounded</i></b> or <b><i>smooth pulse</i></b>.
And like the "fuzzy step" function described above, we can think of a 
smooth pulse in terms of a square pulse with a controllable amount or "fuzz". 
Note that if <i>fuzz</i> = 0, we get a square pulse. If <i>fuzz</i> = (<i>b</i> - <i>a</i>) / 2, we get a completely rounded-off pulse (there is no flat portion on top).
</p>

<p align=center>
<img src="pulse.gif"><br><br>
<code>smoothstep(<i>a</i> - <i>fuzz</i>, <i>a</i>, <i>x</i>) - smoothstep(<i>b</i> - <i>fuzz</i>, <i>b</i>, <i>x</i>)</code> 
</p>

<table border=3 cellpadding=5 width=100%>
<tr><td>
<p align=right><small>RManNotes function</small></p>
<p>
<b>float pulse(float a, b, fuzz, x)</b>
</p>
<p>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<i>A "fuzzy" pulse; it returns the value of smoothstep(a - fuzz, a, x) - smoothstep(b - fuzz, b, x).
</i></p>
</table>

<h2><a name="cross_tile">"Cross" Tile</h2>

The horizontal and vertical bars in the tile below were generated using two 
<a href="#pulse">pulses</a> each in a different layer.
<p>

<p align=center>
<img src="crosstile.gif"><br>
<a href="crosstile.sl">crosstile.sl</a>
</p>

<p><img src="black_line.gif"></p>
<p>
<a href="tiling.html">previous</a>
|
<a href="mod.html">next</a>
|
<a href="index.html">regular patterns: <b>contents</b></a>
|
<a href="../index.html">rmannotes: <b>top</b></a>
</i>
</p>

<p><img src="black_line.gif"></p> <small> <p><i>RManNotes</i> is Copyright &copy; 1995, 1996 Stephen F. May</p> <p> <i>Any comments or suggestions appreciated.</i> <address><a href="http://www.cgrg.ohio-state.edu/~smay">Steve May</a> (<a href="mailto:smay@cgrg.ohio-state.edu">smay@cgrg.ohio-state.edu</a>)</address> </p> </small>

<p align=right><small><i>Last Modified: 4/15/96</i></small></p>

</body>
</html>
